Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

'---------------------------------
' EPX-30SC API library definitions
'---------------------------------

Module EPX30SC

	'
	' Device status (Return codes)
	'
    Public Const EPX30SC_OK As Integer = 0
    Public Const EPX30SC_INVALID_HANDLE As Integer = 1
    Public Const EPX30SC_DEVICE_NOT_FOUND As Integer = 2
    Public Const EPX30SC_DEVICE_NOT_OPENED As Integer = 3
    Public Const EPX30SC_OTHER_ERROR As Integer = 4
    Public Const EPX30SC_COMMUNICATION_ERROR As Integer = 5
    Public Const EPX30SC_INVALID_PARAMETER As Integer = 6


	'
	' Counter Mode
	'
	Public Const EPX30SC_CNT_MODE_1PHASE As Byte = 0
	Public Const EPX30SC_CNT_MODE_2PHASE As Byte = 1

	'
	' Counter Direction
	'
	Public Const EPX30SC_CNT_DIR_UP As Byte = 0
	Public Const EPX30SC_CNT_DIR_DOWN As Byte = 1

	'
	' Counter Control
	'
	Public Const EPX30SC_CNT_DISABLE As Byte = 0
	Public Const EPX30SC_CNT_ENABLE As Byte = 1

	'
	' Counter Status
	'
	Public Const EPX30SC_CNT_OK As Byte = 0
	Public Const EPX30SC_CNT_OVF As Byte = 1
	Public Const EPX30SC_CNT_UDF As Byte = 2

	'
	' Counter External Control
	'
	Public Const EPX30SC_CNT_EX_DISABLE As Byte = 0
	Public Const EPX30SC_CNT_EX_ENABLE As Byte = 1

	'
	' Counter Latch Flag
	'
	Public Const EPX30SC_CNT_LAT_FALSE As Byte = 0
	Public Const EPX30SC_CNT_LAT_TRUE As Byte = 1


	'
	' I/O Port
	'
    Public Const EPX30SC_PORT0 As Byte = 0
    Public Const EPX30SC_PORT1 As Byte = 1
    Public Const EPX30SC_PORT2 As Byte = 2
    Public Const EPX30SC_PORT3 As Byte = 3

	'
	' Port Direction
	'
    Public Const EPX30SC_PORT_DIR_INPUT As Byte = 0
    Public Const EPX30SC_PORT_DIR_OUTPUT As Byte = 1


	'
	' Device Functions
	'
    Public Declare Function EPX30SC_GetNumberOfDevices Lib "EPX30SC.dll" (ByRef Number As Integer) As Integer
    Public Declare Function EPX30SC_GetSerialNumber Lib "EPX30SC.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function EPX30SC_Open Lib "EPX30SC.dll" (ByRef Handle As System.IntPtr) As Integer
    Public Declare Function EPX30SC_OpenBySerialNumber Lib "EPX30SC.dll" (ByVal SerialNumber As Integer, ByRef Handle As System.IntPtr) As Integer
    Public Declare Function EPX30SC_Close Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr) As Integer

 	'
	' Counter Functions
	'
    Public Declare Function EPX30SC_SetCounterMode Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByVal Mode As Byte) As Integer
    Public Declare Function EPX30SC_GetCounterMode Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByRef Mode As Byte) As Integer
    Public Declare Function EPX30SC_SetCounterDirection Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByVal Direction As Byte) As Integer
    Public Declare Function EPX30SC_GetCounterDirection Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByRef Direction As Byte) As Integer
    Public Declare Function EPX30SC_SetCounterControl Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByVal Control As Byte) As Integer
    Public Declare Function EPX30SC_GetCounterControl Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByRef Control As Byte) As Integer
    Public Declare Function EPX30SC_ResetCounter Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr) As Integer
    Public Declare Function EPX30SC_GetCounterValue Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByRef Value As Integer) As Integer
    Public Declare Function EPX30SC_GetCounterStatus Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByRef Status As Byte) As Integer
    Public Declare Function EPX30SC_GetCounterExControl Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByRef Control As Byte) As Integer
    Public Declare Function EPX30SC_GetCounterLatchFlag Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByRef Flag As Byte) As Integer
    Public Declare Function EPX30SC_GetCounterLatchValue Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByRef Value As Integer) As Integer

 	'
	' I/O Port Functions
	'
    Public Declare Function EPX30SC_SetPortDirection Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByVal Direction As Byte) As Integer
    Public Declare Function EPX30SC_GetPOrtDirection Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByRef Direction As Byte) As Integer
    Public Declare Function EPX30SC_OutputPort Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByVal Value As Byte) As Integer
    Public Declare Function EPX30SC_InputPort Lib "EPX30SC.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByRef Value As Byte) As Integer


End Module
